Exemple #1
0
        /// <summary>
        /// Implement this method as an external command for Revit.
        /// </summary>
        /// <param name="commandData">An object that is passed to the external application
        /// which contains data related to the command,
        /// such as the application object and active view.</param>
        /// <param name="message">A message that can be set by the external application
        /// which will be displayed if a failure or cancellation is returned by
        /// the external command.</param>
        /// <param name="elements">A set of elements to which the external application
        /// can add elements that are to be highlighted in case of failure or cancellation.</param>
        /// <returns>Return the status of the external command.
        /// A result of Succeeded means that the API external method functioned as expected.
        /// Cancelled can be used to signify that the user cancelled the external operation
        /// at some point. Failure should be returned if the application is unable to proceed with
        /// the operation.</returns>
        public virtual Result Execute(ExternalCommandData commandData
                                      , ref string message, ElementSet elements)
        {
            try
            {
                Document document           = commandData.Application.ActiveUIDocument.Document;
                Autodesk.Revit.DB.View view = commandData.Application.ActiveUIDocument.ActiveView;
                viewDic.Clear();
                ElementId datumRef = commandData.Application.ActiveUIDocument.Selection.GetElementIds().First();
                if (datumRef == null)
                {
                    return(Result.Cancelled);
                }

                DatumPlane       datum    = document.GetElement(datumRef) as DatumPlane;
                ISet <ElementId> viewList = datum.GetPropagationViews(view);
                foreach (ElementId id in viewList)
                {
                    Autodesk.Revit.DB.View pView = document.GetElement(id) as Autodesk.Revit.DB.View;
                    if (!viewDic.Keys.Contains(pView.ViewType + " : " + pView.Name))
                    {
                        viewDic.Add(pView.ViewType + " : " + pView.Name, id);
                    }
                }

                //// Show UI
                using (PropogateSetting settingForm = new PropogateSetting())
                {
                    if (settingForm.ShowDialog() == DialogResult.OK)
                    {
                        ISet <ElementId> pViewList = new List <ElementId>() as ISet <ElementId>;
                        foreach (var item in settingForm.propagationViewList.CheckedItems)
                        {
                            ElementId selectedView = viewDic[item.ToString()];
                            pViewList.Add(selectedView);
                        }
                        using (Transaction tran = new Transaction(document, "propagation"))
                        {
                            tran.Start();
                            datum.PropagateToViews(view, pViewList);
                            tran.Commit();
                        }
                    }
                }
                return(Result.Succeeded);
            }
            catch (Exception ex)
            {
                message = ex.Message;
                return(Result.Failed);
            }
        }